
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.testt.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.BuildCreativeModeTabContentsEvent;

import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.CreativeModeTabs;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.network.chat.Component;
import net.minecraft.core.registries.Registries;

import net.mcreator.testt.TesttMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class TesttModTabs {
	public static final DeferredRegister<CreativeModeTab> REGISTRY = DeferredRegister.create(Registries.CREATIVE_MODE_TAB, TesttMod.MODID);
	public static final RegistryObject<CreativeModeTab> ORBITAL_EXPLORATION = REGISTRY.register("orbital_exploration",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.testt.orbital_exploration")).icon(() -> new ItemStack(Blocks.SLIME_BLOCK)).displayItems((parameters, tabData) -> {
				tabData.accept(TesttModBlocks.LASER_BLOCK.get().asItem());
				tabData.accept(TesttModItems.ORBITAL_POINTER.get());
				tabData.accept(TesttModBlocks.PROJECT_BEAM.get().asItem());
				tabData.accept(TesttModItems.MAKESHIFT_GUN.get());
				tabData.accept(TesttModItems.BLANK.get());
			}).withSearchBar().build());

	@SubscribeEvent
	public static void buildTabContentsVanilla(BuildCreativeModeTabContentsEvent tabData) {
		if (tabData.getTabKey() == CreativeModeTabs.SPAWN_EGGS) {
			tabData.accept(TesttModItems.CHOMP_SPAWN_EGG.get());
		} else if (tabData.getTabKey() == CreativeModeTabs.TOOLS_AND_UTILITIES) {
			tabData.accept(TesttModItems.SPACE.get());
		}
	}
}
