
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.testt.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.entity.EntityAttributeCreationEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;

import net.mcreator.testt.entity.ScrapShotEntity;
import net.mcreator.testt.entity.OrbitalPointerProjectileEntity;
import net.mcreator.testt.entity.ChompEntity;
import net.mcreator.testt.TesttMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class TesttModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.ENTITY_TYPES, TesttMod.MODID);
	public static final RegistryObject<EntityType<OrbitalPointerProjectileEntity>> ORBITAL_POINTER_PROJECTILE = register("orbital_pointer_projectile",
			EntityType.Builder.<OrbitalPointerProjectileEntity>of(OrbitalPointerProjectileEntity::new, MobCategory.MISC).setCustomClientFactory(OrbitalPointerProjectileEntity::new).setShouldReceiveVelocityUpdates(true).setTrackingRange(64)
					.setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final RegistryObject<EntityType<ScrapShotEntity>> SCRAP_SHOT = register("scrap_shot",
			EntityType.Builder.<ScrapShotEntity>of(ScrapShotEntity::new, MobCategory.MISC).setCustomClientFactory(ScrapShotEntity::new).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final RegistryObject<EntityType<ChompEntity>> CHOMP = register("chomp",
			EntityType.Builder.<ChompEntity>of(ChompEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(ChompEntity::new)

					.sized(0.6f, 1.8f));

	private static <T extends Entity> RegistryObject<EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(registryname));
	}

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		event.enqueueWork(() -> {
			ChompEntity.init();
		});
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(CHOMP.get(), ChompEntity.createAttributes().build());
	}
}
